function AaoPfdLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastAaoSend = '';
	var dloop;
	var lastString = "";
	var isActive = false;

	function DataLoop () {
		let apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let requestObj = {};
			requestObj.setstringvars = [];
			requestObj.setvars = [];
			let wpfds = document.getElementsByTagName("wtg3000-pfd");
			if (wpfds && wpfds.length > 0){
				let gtcindex = SimVar.GetSimVarValue('L:PFD_INDEX', 'Number');
				let indexStr = "Index=" + (gtcindex + 1).toString();
				if (wpfds[0].getAttribute("url").indexOf(indexStr) < 0){
					isActive = false;
					return;
				}else{
					if (!isActive){
						isActive = true;
						lastString = "";
					}
				}
			}
			// read softkey labels
			let currStr = "";
			for (let i = 0; i < 12; i++){
				let skeys = document.getElementsByClassName("softkey-" + i.toString());
				if (skeys && skeys.length > 0){
					let sval = "";
					let indval = 0;
					let enval = 1;
					if (skeys[0]) {
						if (skeys[0].className.indexOf("softkey-disabled") > 0){
							enval = 0;
						}
						let slabs = skeys[0].getElementsByClassName("softkey-label");
						if (slabs && slabs.length > 0)
							sval = slabs[0].textContent.replace(/(\r\n|\n|\r)/gm, " ");
						if (skeys[0].className.indexOf("softkey-value-text-show") > 0){
							slabs = skeys[0].getElementsByClassName("softkey-value-text");
							if (slabs && slabs.length > 0)
								sval = sval + " | " + slabs[0].textContent;
						}
						if (skeys[0].className.indexOf("softkey-value-toggle-show") > 0){
							indval = 1;
							slabs = skeys[0].getElementsByClassName("toggle-status-bar-on");
							if (slabs && slabs.length > 0)
								indval = 2;
						}
					}
					currStr = currStr + "_" + sval + indval.toString() + enval.toString();
					let toset = { "var": "(L:G3000_PFD_SOFTKEY_" + (i + 1).toString() + ", String)", "value": sval };
					requestObj.setstringvars.push(toset);
					toset = { "var": "(L:G3000_PFD_SOFTKEY_" + (i + 1).toString() + "_INDICATOR)", "value": indval };
					requestObj.setvars.push(toset);
					toset = { "var": "(L:G3000_PFD_SOFTKEY_" + (i + 1).toString() + "_ENABLED)", "value": enval };
					requestObj.setvars.push(toset);
				}
			}
			if (currStr !== lastString){
				lastString = currStr;
				let relxhttp = new XMLHttpRequest();
				let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
				relxhttp.open("POST", relurl);
				relxhttp.send(JSON.stringify(requestObj));
			}
		}
	};

	this.startup = function () {
		dloop = setInterval(DataLoop, 150);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaopfdmodule = new AaoPfdLink();
aaopfdmodule.startup();
